Macでeclipse の実行の構成設定ができない

受付中

回答 2

投稿

  • 評価
  • クリップ 0
  • VIEW 328

harunyan333

score 6

前提・実現したいこと

プログラミング初心者です。
Macのパソコンでeclipseを使い、javaFXのプログラムを実行させようとしています。
プログラムにエラーは生じないのですが実行させようとすると

発生している問題・エラーメッセージ

プログラムにエラーは生じないのですが実行させようとするとエラーが出てきます。

Error occurred during initialization of boot layer
java.lang.module.FindException: Error reading module: /Applications/Eclipse_2019-03.app/Contents/workspace/Lesson01/bin
Caused by: java.lang.module.InvalidModuleDescriptorException: Sample2.class found in top-level directory (unnamed package not allowed in module)

こんな感じです。

試したこと

openJDK12.0.1とjavafx-sdk-11.0をインストールしました。
JDKはjava_homeの設定調べてしてみました。
その後eclipseの実行の構成の環境にPATH:/Library/Java/Java/VirtualMachines/jdk-12.0.1.jdk/Contents/Home/binとjava_homeの設定と同じものを入れました。

補足情報(FW/ツールのバージョンなど)

eclipseのバージョンはこれです。
Eclipse 4.11 for Mac OS X, Copyright IBM Corp. and others 2002, 2019. All rights reserved

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 2

0

Sample2.class found in top-level directory (unnamed package not allowed in module)
【Google翻訳】
最上位ディレクトリにSample2.classが見つかりました(名前のないパッケージはモジュールでは使用できません)

Sample2クラスのパッケージが問題ではないでしょうか。

デフォルトパッケージやめれば良い的な回答があるので、ソースコードの一行目に
package hello;
と書けばよいかと
(参考:javaについて 「Hello,eclipse!」を表示する...

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/05/28 07:57

    回答ありがとうございます。
    実はわけわかんなくなってしまってアンインストールして初めから調べ直して設定しなおすことにしました。

    ちなみにSample2ではなくSample1を作った記憶しかないのですが、例えばクラスの消し方もしくはクラス名の変え方などはありますか?
    package helloもぜひ今後参考にさせていただきます。

    キャンセル

0

プログラムにエラーは生じない

おそらくソースファイルの先頭行付近の行番号の左側あたりに赤の×印が出てると思います。つまり実は「ソースコードに問題がある」のです。

エラーメッセージの意味はdsuzukiさんが回答しておられますが、なぜこうなるかはJava9から導入されたモジュールの仕様に関係してきます。(これからJavaを学ぶ方はモジュールについて最小限の知識が必要になると思います。下手をするとJava8以前を前提としたサンプルだとHelloWorldでさえ動かないなんてことになりかねません。)

質問者さんはJava12を動かすためにmarketplaceなどでJava 12 Support for Eclipse 2019-03 (4.11) 4.11を導入済みと思います。それ入れてないとご質問のエラーが出るところまで到達しませんので。

さてプロジェクトを作るときデフォルトでmodule-info.javaが生成されますが。ここには外部モジュールの参照設定や自分自身で書いているアプリケーションのパッケージの公開宣言などを記述することになっています。どのようなJavaFXアプリケーションを書かれているか不明ですが、例えばごく簡単な以下のサンプルを仮定してみますと・・・

package com.example.jfx;

import javafx.application.Application;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.layout.BorderPane;
import javafx.scene.text.Font;
import javafx.stage.Stage;

public class HelloJfx extends Application {
  @Override
  public void start(Stage stage) throws Exception {
    var root = new BorderPane();
    var label = new Label("Hello JFX");
    label.setFont(Font.font(32));
    label.setAlignment(Pos.CENTER);
    label.setPrefSize(200, 100);
    root.setCenter(label);
    stage.setScene(new Scene(root));
    stage.show();
  }
}


これを正常にコンパイルするためにはmodule-info.javaはこんなふうになっていることが期待です。

module-info.java

module your.favolite.module.name { // モジュール名は好きに付けます
  exports com.example.jfx;  // (A) Applicationクラスが存在するパッケージをexport
  requires javafx.graphics; // JavaFXアプリケーションを作るときに必須のモジュール
  requires javafx.controls; // JavaFXの色んなコントロールを使うときに必須のモジュール
}

さて、(A)をみますとアプリケーションで定義したもののうち外部へ公開するクラスをパッケージ単位で指定することがわかります。もし公開するクラスがデフォルトパッケージにあるとパッケージ名がないので

exports ;

などとしか表現できなくなりますが、そのような病的なexportsは許さない仕様なのでしょう。それゆえ事実上デフォルトパッケージはもはや「使うべきでないパッケージ」になったといえると思います。


厳密には互換性のためにmodule-info.javaをプロジェクト内で作らずにアプリケーションを記述することもできます。そのかわりコンパイル(javacコマンド)や実行(javaコマンド)に特別なオプションを指定しなくてはならなくなります。Eclipseがそういうケースをうまく配慮してくれるのかどうか自分にはわかりません。EclipseでないIDEを使っているためです。自分が使っているのはIntelliJ IDEAですがこのIDEですと最近のバージョンアップでmodule-info.javaを作らなかったときに自動的に必要なオプションを補完してコンパイルしたり実行してくれるようになったようです(ちょっと古いバージョンでは実行構成に一々オプションを指定せねばならずかなり面倒でした)。Eclipseは大変よく使われているIDEですので現時点でも(あるいは近い将来)そういう配慮がなされるような気がします)

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/05/28 08:06

    回答ありがとうございます。
    実はまた初めからインストールし直すことにしました。

    javaは最新版なのでeclipse_2019-3をインストールして使っていました。(ちなみに、インストールし直したやつも同じです。)
    module-info.javaは授業でも出てきたことがなかったので初めてみました。
    そちらについても調べてみようとおもます。

    キャンセル

  • 2019/05/28 08:55

    javaの最新版はjava12ですがeclipseの最新版eclipse 2019-03はまだデフォルトの状態でjava12には対応していません。何度インストールしなおしてもそれは同じです。インストールしなおしたのなら再度
    Java 12 Support for Eclipse 2019-03 (4.11) 4.11
    も追加でインストールする必要があります。(そのうちEclipseがJava12に対応すればこうした作業は不要になるでしょうが)

    勉強のためならとりあえずJava8くらいでよい気もしますが、Java12を使うかJava8を使うか講師の方に相談してみるのがよいかも知れません。もしJava8でよいと言われたらJava12をアンインストールしてJava8の方をインストールしてください。そうすればEclipseにJava12用の追加インストールをしなくてもすみますし、他にもいろいろ手間が省ける気がします。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.21%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる